# Neops Task Engine Client
Neops workflow engine API documentation

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Package version: 0.41.12-beta.8
- Generator version: 7.9.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import neops_workflow_engine_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import neops_workflow_engine_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import neops_workflow_engine_client
from neops_workflow_engine_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = neops_workflow_engine_client.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with neops_workflow_engine_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = neops_workflow_engine_client.BlackboardApi(api_client)
    job_log_dto = neops_workflow_engine_client.JobLogDto() # JobLogDto | 

    try:
        # 
        api_instance.blackboard_controller_add_job_log(job_log_dto)
    except ApiException as e:
        print("Exception when calling BlackboardApi->blackboard_controller_add_job_log: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BlackboardApi* | [**blackboard_controller_add_job_log**](docs/BlackboardApi.md#blackboard_controller_add_job_log) | **POST** /blackboard/job/log | 
*BlackboardApi* | [**blackboard_controller_poll_job**](docs/BlackboardApi.md#blackboard_controller_poll_job) | **POST** /blackboard/job | 
*BlackboardApi* | [**blackboard_controller_push_job_result**](docs/BlackboardApi.md#blackboard_controller_push_job_result) | **POST** /blackboard/job/result | 
*DefaultApi* | [**app_controller_get_hello**](docs/DefaultApi.md#app_controller_get_hello) | **GET** / | 
*DefaultApi* | [**app_controller_get_version**](docs/DefaultApi.md#app_controller_get_version) | **GET** /version | 
*FunctionBlockApi* | [**function_blocks_controller_find_all**](docs/FunctionBlockApi.md#function_blocks_controller_find_all) | **GET** /function-blocks/registrations/list | List all registered function blocks
*FunctionBlockApi* | [**function_blocks_controller_find_one_fb**](docs/FunctionBlockApi.md#function_blocks_controller_find_one_fb) | **GET** /function-blocks/{pkg}/{name}/{version} | Get a function block by ID
*FunctionBlockApi* | [**function_blocks_controller_find_one_fb_registration**](docs/FunctionBlockApi.md#function_blocks_controller_find_one_fb_registration) | **GET** /function-blocks/registrations/{pkg}/{name}/{version} | Get a function block registration by ID
*FunctionBlockApi* | [**function_blocks_controller_register**](docs/FunctionBlockApi.md#function_blocks_controller_register) | **POST** /function-blocks/register | Register a function block
*FunctionBlockApi* | [**function_blocks_controller_soft_delete**](docs/FunctionBlockApi.md#function_blocks_controller_soft_delete) | **DELETE** /function-blocks/{pkg}/{name}/{version} | Soft-delete a function block by ID
*HealthApi* | [**health_controller_healthy**](docs/HealthApi.md#health_controller_healthy) | **GET** /health | Check service health status
*WorkflowsApi* | [**workflow_definition_controller_create**](docs/WorkflowsApi.md#workflow_definition_controller_create) | **POST** /workflow-definition | Create a Workflow definition
*WorkflowsApi* | [**workflow_definition_controller_find_all**](docs/WorkflowsApi.md#workflow_definition_controller_find_all) | **GET** /workflow-definition | Retrieve all workflow definitions
*WorkflowsApi* | [**workflow_definition_controller_find_one**](docs/WorkflowsApi.md#workflow_definition_controller_find_one) | **GET** /workflow-definition/{id} | Retrieve a workflow definitions by ID
*WorkflowsApi* | [**workflow_definition_controller_soft_delete**](docs/WorkflowsApi.md#workflow_definition_controller_soft_delete) | **DELETE** /workflow-definition/{id} | Soft-delete a workflow definition by ID
*WorkflowsApi* | [**workflow_execution_controller_abort**](docs/WorkflowsApi.md#workflow_execution_controller_abort) | **DELETE** /workflow-execution/{id} | Abort a running workflow execution
*WorkflowsApi* | [**workflow_execution_controller_execute**](docs/WorkflowsApi.md#workflow_execution_controller_execute) | **POST** /workflow-execution | Add a workflow execution to the table
*WorkflowsApi* | [**workflow_execution_controller_find_all**](docs/WorkflowsApi.md#workflow_execution_controller_find_all) | **GET** /workflow-execution/state/{state} | Retrieve all workflow executions by state
*WorkflowsApi* | [**workflow_execution_controller_find_one**](docs/WorkflowsApi.md#workflow_execution_controller_find_one) | **GET** /workflow-execution/id/{id} | Retrieve a specific workflow execution by ID


## Documentation For Models

 - [CreateWorkflowDefinitionDto](docs/CreateWorkflowDefinitionDto.md)
 - [CronConfiguration](docs/CronConfiguration.md)
 - [CrontabConfiguration](docs/CrontabConfiguration.md)
 - [EntityUpdateDto](docs/EntityUpdateDto.md)
 - [ExecuteWorkflowDto](docs/ExecuteWorkflowDto.md)
 - [FunctionBlockFullIdentificationDto](docs/FunctionBlockFullIdentificationDto.md)
 - [HealthResponse](docs/HealthResponse.md)
 - [JobDefinitionDto](docs/JobDefinitionDto.md)
 - [JobExecutionContextDto](docs/JobExecutionContextDto.md)
 - [JobExecutionResultDbUpdatesDto](docs/JobExecutionResultDbUpdatesDto.md)
 - [JobExecutionResultDto](docs/JobExecutionResultDto.md)
 - [JobLogDto](docs/JobLogDto.md)
 - [JobPollDto](docs/JobPollDto.md)
 - [JobResultDto](docs/JobResultDto.md)
 - [ParametrizedFunctionBlock](docs/ParametrizedFunctionBlock.md)
 - [RegisterFunctionBlockDto](docs/RegisterFunctionBlockDto.md)
 - [RepeatConfiguration](docs/RepeatConfiguration.md)
 - [RetryConfiguration](docs/RetryConfiguration.md)
 - [RootWorkflow](docs/RootWorkflow.md)
 - [Workflow](docs/Workflow.md)
 - [WorkflowConfig](docs/WorkflowConfig.md)
 - [WorkflowExecutionParameters](docs/WorkflowExecutionParameters.md)
 - [WorkflowReference](docs/WorkflowReference.md)
 - [WorkflowStepsInner](docs/WorkflowStepsInner.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="JWT"></a>
### JWT

- **Type**: Bearer authentication (JWT)


## Author




