# coding: utf-8

"""
    Neops Workflow Engine

    Neops workflow engine API documentation

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from neops_workflow_engine_client.models.entity_update_dto import EntityUpdateDto
from typing import Optional, Set
from typing_extensions import Self

class JobExecutionResultDbUpdatesDto(BaseModel):
    """
    JobExecutionResultDbUpdatesDto
    """ # noqa: E501
    device_updates: Optional[List[EntityUpdateDto]] = Field(default=None, description="Array of updates applied to devices", alias="deviceUpdates")
    group_updates: Optional[List[EntityUpdateDto]] = Field(default=None, description="Array of updates applied to device groups", alias="groupUpdates")
    __properties: ClassVar[List[str]] = ["deviceUpdates", "groupUpdates"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JobExecutionResultDbUpdatesDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in device_updates (list)
        _items = []
        if self.device_updates:
            for _item_device_updates in self.device_updates:
                if _item_device_updates:
                    _items.append(_item_device_updates.to_dict())
            _dict['deviceUpdates'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in group_updates (list)
        _items = []
        if self.group_updates:
            for _item_group_updates in self.group_updates:
                if _item_group_updates:
                    _items.append(_item_group_updates.to_dict())
            _dict['groupUpdates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JobExecutionResultDbUpdatesDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "deviceUpdates": [EntityUpdateDto.from_dict(_item) for _item in obj["deviceUpdates"]] if obj.get("deviceUpdates") is not None else None,
            "groupUpdates": [EntityUpdateDto.from_dict(_item) for _item in obj["groupUpdates"]] if obj.get("groupUpdates") is not None else None
        })
        return _obj


